searchNodes=[{"doc":"Starts the mailbox preview server.Command line optionsThis task accepts the same command-line arguments as run. For additional information, refer to the documentation for Mix.Tasks.Run.For example, to run swoosh.mailbox.server without checking dependencies:mix swoosh.mailbox.server --no-deps-checkThe --no-halt flag is automatically added.","ref":"Mix.Tasks.Swoosh.Mailbox.Server.html","title":"Mix.Tasks.Swoosh.Mailbox.Server","type":"task"},{"doc":"Callback implementation for Mix.Task.run/1.","ref":"Mix.Tasks.Swoosh.Mailbox.Server.html#run/1","title":"Mix.Tasks.Swoosh.Mailbox.Server.run/1","type":"function"},{"doc":"Plug that serves pages useful for previewing emails in development.It takes one option at initialization:base_path - sets the base URL path where this module is plugged. Defaults to /.Examples# in a Phoenix router defmodule Sample.Router do scope &quot;/dev&quot; do pipe_through [:browser] forward &quot;/mailbox&quot;, Plug.Swoosh.MailboxPreview, [base_path: &quot;/dev/mailbox&quot;] end end","ref":"Plug.Swoosh.MailboxPreview.html","title":"Plug.Swoosh.MailboxPreview","type":"module"},{"doc":"Callback implementation for Plug.call/2.","ref":"Plug.Swoosh.MailboxPreview.html#call/2","title":"Plug.Swoosh.MailboxPreview.call/2","type":"function"},{"doc":"Callback implementation for Plug.init/1.","ref":"Plug.Swoosh.MailboxPreview.html#init/1","title":"Plug.Swoosh.MailboxPreview.init/1","type":"function"},{"doc":"Compose, deliver and test your emails easily in Elixir.We have applied the lessons learned from projects like Plug, Ecto and Phoenix in designing clean and composable APIs, with clear separation of concerns between modules. Out of the box it comes with adapters for Sendgrid, Mandrill, Mailgun, Postmark and SparkPost, as well as SMTP.The complete documentation for Swoosh is located here.Getting started# In your config/config.exs file config :sample, Sample.Mailer, adapter: Swoosh.Adapters.Sendgrid, api_key: &quot;SG.x.x&quot; # In your application code defmodule Sample.Mailer do use Swoosh.Mailer, otp_app: :sample end defmodule Sample.UserEmail do import Swoosh.Email def welcome(user) do new() |&gt; to({user.name, user.email}) |&gt; from({&quot;Dr B Banner&quot;, &quot;hulk.smash@example.com&quot;}) |&gt; subject(&quot;Hello, Avengers!&quot;) |&gt; html_body(&quot;&lt;h1&gt;Hello \#{user.name}&lt;/h1&gt;&quot;) |&gt; text_body(&quot;Hello \#{user.name}\\n&quot;) end end # In an IEx session Sample.UserEmail.welcome(%{name: &quot;Tony Stark&quot;, email: &quot;tony.stark@example.com&quot;}) |&gt; Sample.Mailer.deliver # Or in a Phoenix controller defmodule Sample.UserController do use Phoenix.Controller alias Sample.UserEmail alias Sample.Mailer def create(conn, params) do user = # create user logic UserEmail.welcome(user) |&gt; Mailer.deliver end endSee Mailer docs for more configuration options.InstallationAdd swoosh to your list of dependencies in mix.exs: def deps do [{:swoosh, &quot;~&gt; 1.0&quot;}] end(Optional-ish) Most Adapters (Non SMTP ones) use Swoosh.ApiClient to talk to the service provider. Swoosh comes with Swoosh.ApiClient.Hackney. if you want to use the default, include :hackney as a dependency as well. Otherwise, define a new API client that uses the HTTP client you like, and config swoosh to use the new API Client. See Swoosh.ApiClient and Swoosh.ApiClient.Hackney for details. config :swoosh, :api_client, MyApp.ApiClient(Optional) If you are using Swoosh.Adapters.SMTP, Swoosh.Adapters.Sendmail or Swoosh.Adapters.AmazonSES, you also need to add gen_smtp to your deps and list of applications: def deps do [ {:swoosh, &quot;~&gt; 1.0&quot;}, {:gen_smtp, &quot;~&gt; 0.13&quot;} ] endAdaptersSwoosh supports the most popular transactional email providers out of the box and also has a SMTP adapter. Below is the list of the adapters currently included:ProviderSwoosh adapterSMTPSwoosh.Adapters.SMTPSendgridSwoosh.Adapters.SendgridSendmailSwoosh.Adapters.SendmailMandrillSwoosh.Adapters.MandrillMailgunSwoosh.Adapters.MailgunMailjetSwoosh.Adapters.MailjetPostmarkSwoosh.Adapters.PostmarkSparkPostSwoosh.Adapters.SparkPostAmazon SESSwoosh.Adapters.AmazonSESDynSwoosh.Adapters.DynSocketLabsSwoosh.Adapters.SocketLabsGmailSwoosh.Adapters.GmailConfigure which adapter you want to use by updating your config/config.exs file:config :sample, Sample.Mailer, adapter: Swoosh.Adapters.SMTP # adapter config (api keys, etc.)Check the documentation of the adapter you want to use for more specific configurations and instructions.Adding new adapters is super easy and we are definitely looking for contributions on that front. Get in touch if you want to help!Async EmailsSwoosh does not make any special arrangements for sending emails in a non-blocking manner.To send asynchronous emails in Swoosh, one can simply leverage Elixir's standard library:Task.start(fn -&gt; %{name: &quot;Tony Stark&quot;, email: &quot;tony.stark@example.com&quot;} |&gt; Sample.UserEmail.welcome |&gt; Sample.Mailer.deliver end)Please take a look at the official docs for Task and Task.Supervisor for further options.Note: it is not to say that Task.start is enough to cover the whole async aspect of sending emails. It is more to say that the implementation of sending emails is very application specific. For example, the simple example above might be sufficient for some small applications but not so much for more mission critial applications. Runtime errors, network errors and errors from the service provider all need to be considered and handled, maybe differently as well. Whether to retry, how many times you want to retry, what to do when everything fails, these questions all have different answers in different context.Phoenix integrationIf you are looking to use Swoosh in your Phoenix project, make sure to check out the phoenix_swoosh project. It contains a set of functions that make it easy to render the text and HTML bodies using Phoenix views, templates and layouts.Taking the example from above the &quot;Getting Started&quot; section, your code would look something like this:# web/templates/layout/email.html.eex &lt;html&gt; &lt;head&gt; &lt;title&gt;&lt;%= @email.subject %&gt;&lt;/title&gt; &lt;/head&gt; &lt;body&gt; &lt;%= @inner_content %&gt; &lt;/body&gt; &lt;/html&gt; # web/templates/email/welcome.html.eex &lt;div&gt; &lt;h1&gt;Welcome to Sample, &lt;%= @username %&gt;!&lt;/h1&gt; &lt;/div&gt; # web/emails/user_email.ex defmodule Sample.UserEmail do use Phoenix.Swoosh, view: Sample.EmailView, layout: {Sample.LayoutView, :email} def welcome(user) do new() |&gt; to({user.name, user.email}) |&gt; from({&quot;Dr B Banner&quot;, &quot;hulk.smash@example.com&quot;}) |&gt; subject(&quot;Hello, Avengers!&quot;) |&gt; render_body(&quot;welcome.html&quot;, %{username: user.username}) end endFeels familiar doesn't it? Head to the phoenix_swoosh repo for more details.AttachmentsYou can attach files to your email using the Swoosh.Email.attachment/2 function. Just give the path of your file as an argument and we will do the rest. It also works with a %Plug.Upload{} struct, or a %Swoosh.Attachment{} struct, which can be constructed using Swoosh.Attachment.new detailed here in the docs.All built-in adapters have support for attachments.new() |&gt; to(&quot;peter@example.com&quot;) |&gt; from({&quot;Jarvis&quot;, &quot;jarvis@example.com&quot;}) |&gt; subject(&quot;Invoice May&quot;) |&gt; text_body(&quot;Here is the invoice for your superhero services in May.&quot;) |&gt; attachment(&quot;/Users/jarvis/invoice-peter-may.pdf&quot;)TestingIn your config/test.exs file set your mailer's adapter to Swoosh.Adapters.Test so that you can use the assertions provided by Swoosh in Swoosh.TestAssertions module.defmodule Sample.UserTest do use ExUnit.Case, async: true import Swoosh.TestAssertions test &quot;send email on user signup&quot; do # Assuming `create_user` creates a new user then sends out a `Sample.UserEmail.welcome` email user = create_user(%{username: &quot;ironman&quot;, email: &quot;tony.stark@example.com&quot;}) assert_email_sent Sample.UserEmail.welcome(user) end endMailbox preview in the browserSwoosh ships with a Plug that allows you to preview the emails in the local (in-memory) mailbox. It's particularly convenient in development when you want to check what your email will look like while testing the various flows of your application.For email to reach this mailbox you will need to set your Mailer adapter to Swoosh.Adapters.Local:# in config/dev.exs config :sample, Mailer, adapter: Swoosh.Adapters.Local # to run the preview server together as part of your app config :swoosh, serve_mailbox: true # to change the preview server port (4000 by default) config :swoosh, serve_mailbox: true, preview_port: 4001If you dont want to run the preview server as part of your app as shown above, in your Phoenix project you can also forward directly to the plug if you so choose, like this:# in web/router.ex if Mix.env == :dev do scope &quot;/dev&quot; do pipe_through [:browser] forward &quot;/mailbox&quot;, Plug.Swoosh.MailboxPreview, [base_path: &quot;/dev/mailbox&quot;] end endAnd finally you can also use the following Mix task to start the mailbox preview server independently though note that it won't display/process emails being sent from outside its own process (great for testing within iex).$ mix swoosh.mailbox.serverIf you are curious, this is how it looks:ProductionSwoosh starts a memory storage process for local adapter by default. Normally it does no harm being left around in production. However, if it is causing problems, or you don't like having it around, it can be disabled like so:# config/prod.exs config :swoosh, local: falseDocumentationDocumentation is written into the library, you will find it in the source code, accessible from iex and of course, it all gets published to hexdocs.ContributingWe are grateful for any contributions. Before you submit an issue or a pull request, remember to: Look at our Contributing guidelines Not use the issue tracker for help or support requests (try StackOverflow, IRC or Slack instead) Do a quick search in the issue tracker to make sure the issues hasn't been reported yet. Look and follow the Code of Conduct. Be nice and have fun!Running testsClone the repo and fetch its dependencies:$ git clone https://github.com/swoosh/swoosh.git $ cd swoosh $ mix deps.get $ mix testBuilding docs$ MIX_ENV=docs mix docsLICENSESee LICENSE","ref":"Swoosh.html","title":"Swoosh","type":"module"},{"doc":"Specification of the email delivery adapter.","ref":"Swoosh.Adapter.html","title":"Swoosh.Adapter","type":"behaviour"},{"doc":"Delivers an email with the given config.","ref":"Swoosh.Adapter.html#c:deliver/2","title":"Swoosh.Adapter.deliver/2","type":"callback"},{"doc":"Delivers multiple emails with the given config in one request. Some email providers allow multiple messages to be sent in one HTTP request, for example Mailjet allow this. Check your provider's documentation to see if that is possible.","ref":"Swoosh.Adapter.html#c:deliver_many/2","title":"Swoosh.Adapter.deliver_many/2","type":"callback"},{"doc":"","ref":"Swoosh.Adapter.html#c:validate_config/1","title":"Swoosh.Adapter.validate_config/1","type":"callback"},{"doc":"","ref":"Swoosh.Adapter.html#validate_config/2","title":"Swoosh.Adapter.validate_config/2","type":"function"},{"doc":"","ref":"Swoosh.Adapter.html#c:validate_dependency/0","title":"Swoosh.Adapter.validate_dependency/0","type":"callback"},{"doc":"","ref":"Swoosh.Adapter.html#validate_dependency/1","title":"Swoosh.Adapter.validate_dependency/1","type":"function"},{"doc":"","ref":"Swoosh.Adapter.html#t:config/0","title":"Swoosh.Adapter.config/0","type":"type"},{"doc":"","ref":"Swoosh.Adapter.html#t:email/0","title":"Swoosh.Adapter.email/0","type":"type"},{"doc":"","ref":"Swoosh.Adapter.html#t:t/0","title":"Swoosh.Adapter.t/0","type":"type"},{"doc":"An adapter that sends email using the Amazon Simple Email Service Query API.This email adapter makes use of the Amazon SES SendRawEmail action and generates a SMTP style message containing the information to be emailed. This allows for greater more customizable email message and ensures the capability to add attachments. As a result, however, the gen_smtp dependency is required in order to correctly generate the SMTP message that will be sent.Ensure sure you have the dependency added in your mix.exs file.# You only need to do this if you are using Elixir &lt; 1.4 def application do [applications: [:swoosh, :gen_smtp]] end def deps do [{:swoosh, &quot;~&gt; 0.10.0&quot;}, {:gen_smtp, &quot;~&gt; 0.13.0&quot;}] endSee Also:Amazon SES Query Api DocsAmazon SES SendRawEmail DocumentationExample# config/config.exs config :sample, Sample.Mailer, adapter: Swoosh.Adapters.AmazonSES, region: &quot;region-endpoint&quot;, access_key: &quot;aws-access-key&quot;, secret: &quot;aws-secret-key&quot; # lib/sample/mailer.ex defmodule Sample.Mailer do use Swoosh.Mailer, otp_app: :sample endUsing with tags and configuration setimport Swoosh.Email new() |&gt; from(&quot;guybrush.threepwood@pirates.grog&quot;) |&gt; to(&quot;elaine.marley@triisland.gov&quot;) |&gt; subject(&quot;Mighty Pirate Newsletter&quot;) |&gt; text_body(&quot;Hello&quot;) |&gt; put_provider_option(:tags, [%{name: &quot;name1&quot;, value: &quot;test1&quot;}]) |&gt; put_provider_option(:configuration_set_name, &quot;configuration_set_name1&quot;)IAM roleIn case you use IAM role for authenticating AWS requests, you can fetch temporary access_key and secret_key from that role, but you also need to include additional X-Amz-Security-Token header to that request.You can do that by adding security_token to provider_options.","ref":"Swoosh.Adapters.AmazonSES.html","title":"Swoosh.Adapters.AmazonSES","type":"module"},{"doc":"Callback implementation for Swoosh.Adapter.validate_config/1.","ref":"Swoosh.Adapters.AmazonSES.html#validate_config/1","title":"Swoosh.Adapters.AmazonSES.validate_config/1","type":"function"},{"doc":"Callback implementation for Swoosh.Adapter.validate_dependency/0.","ref":"Swoosh.Adapters.AmazonSES.html#validate_dependency/0","title":"Swoosh.Adapters.AmazonSES.validate_dependency/0","type":"function"},{"doc":"An adapter that sends email using the Dyn API.For reference: Dyn API docsExample# config/config.exs config :sample, Sample.Mailer, adapter: Swoosh.Adapters.Dyn, api_key: &quot;my-api-key&quot;, # lib/sample/mailer.ex defmodule Sample.Mailer do use Swoosh.Mailer, otp_app: :sample end","ref":"Swoosh.Adapters.Dyn.html","title":"Swoosh.Adapters.Dyn","type":"module"},{"doc":"Callback implementation for Swoosh.Adapter.validate_config/1.","ref":"Swoosh.Adapters.Dyn.html#validate_config/1","title":"Swoosh.Adapters.Dyn.validate_config/1","type":"function"},{"doc":"Callback implementation for Swoosh.Adapter.validate_dependency/0.","ref":"Swoosh.Adapters.Dyn.html#validate_dependency/0","title":"Swoosh.Adapters.Dyn.validate_dependency/0","type":"function"},{"doc":"An adapter that sends email using Gmail apiFor reference Gmail API docsDependencyGmail adapter requires Mail dependency to format message as RFC 2822 message.{:mail, &quot;&gt;= 0.0.0&quot;}Because Mail library removes Bcc headers, they are being added after email is rendered, in adapter code.Example# config/congig.exs config :sample, Smaple.Mailer adapter: Swoosh.Adapters.Gmail, access_token: {:system, GMAIL_API_ACCESS_TOKEN} # To deal with token refresh, it could be a better idea to pass the access token # in via deliver config explicitly, if you don&#39;t update the environment variable # periodically. e.g. MyMailer.deliver(my_email, access_token: my_access_token) # lib/sample/mailer.ex defmodule Sample.Mailer do use Swoosh.Mailer, otp_app: :sample endRequired config parameters:access_token valid OAuth2 access token Required scopes:gmail.compose See https://developers.google.com/oauthplayground when developing","ref":"Swoosh.Adapters.Gmail.html","title":"Swoosh.Adapters.Gmail","type":"module"},{"doc":"Callback implementation for Swoosh.Adapter.validate_config/1.","ref":"Swoosh.Adapters.Gmail.html#validate_config/1","title":"Swoosh.Adapters.Gmail.validate_config/1","type":"function"},{"doc":"Callback implementation for Swoosh.Adapter.validate_dependency/0.","ref":"Swoosh.Adapters.Gmail.html#validate_dependency/0","title":"Swoosh.Adapters.Gmail.validate_dependency/0","type":"function"},{"doc":"An adapter that stores the email locally, using the specified storage driver.This is especially useful in development to avoid sending real emails. You can read the emails you have sent using functions in the Swoosh.Adapters.Local.Storage.Memory or the Plug.Swoosh.MailboxPreview plug.Example# config/config.exs config :sample, Sample.Mailer, adapter: Swoosh.Adapters.Local # lib/sample/mailer.ex defmodule Sample.Mailer do use Swoosh.Mailer, otp_app: :sample end","ref":"Swoosh.Adapters.Local.html","title":"Swoosh.Adapters.Local","type":"module"},{"doc":"Callback implementation for Swoosh.Adapter.validate_config/1.","ref":"Swoosh.Adapters.Local.html#validate_config/1","title":"Swoosh.Adapters.Local.validate_config/1","type":"function"},{"doc":"Callback implementation for Swoosh.Adapter.validate_dependency/0.","ref":"Swoosh.Adapters.Local.html#validate_dependency/0","title":"Swoosh.Adapters.Local.validate_dependency/0","type":"function"},{"doc":"In-memory storage driver used by the Swoosh.Adapters.Local module.The emails in this mailbox are stored in memory and won't persist once your application is stopped.","ref":"Swoosh.Adapters.Local.Storage.Memory.html","title":"Swoosh.Adapters.Local.Storage.Memory","type":"module"},{"doc":"List all the emails in the mailbox.Examplesiex&gt; email = new |&gt; from(&quot;tony.stark@example.com&quot;) %Swoosh.Email{from: {&quot;&quot;, &quot;tony.stark@example.com&quot;}, [...]} iex&gt; Memory.push(email) %Swoosh.Email{from: {&quot;&quot;, &quot;tony.stark@example.com&quot;}, headers: %{&quot;Message-ID&quot;: &quot;a1b2c3&quot;}, [...]} iex&gt; Memory.all() [%Swoosh.Email{from: {&quot;&quot;, &quot;tony.stark@example.com&quot;}, headers: %{&quot;Message-ID&quot;: &quot;a1b2c3&quot;}, [...]}]","ref":"Swoosh.Adapters.Local.Storage.Memory.html#all/0","title":"Swoosh.Adapters.Local.Storage.Memory.all/0","type":"function"},{"doc":"Returns a specification to start this module under a supervisor.See Supervisor.","ref":"Swoosh.Adapters.Local.Storage.Memory.html#child_spec/1","title":"Swoosh.Adapters.Local.Storage.Memory.child_spec/1","type":"function"},{"doc":"Delete all the emails currently in the mailbox.Examplesiex&gt; email = new |&gt; from(&quot;tony.stark@example.com&quot;) %Swoosh.Email{from: {&quot;&quot;, &quot;tony.stark@example.com&quot;}, [...]} iex&gt; Memory.push(email) %Swoosh.Email{from: {&quot;&quot;, &quot;tony.stark@example.com&quot;}, headers: %{&quot;Message-ID&quot;: &quot;a1b2c3&quot;}, [...]} iex&gt; Memory.delete_all() :ok iex&gt; Memory.list() []","ref":"Swoosh.Adapters.Local.Storage.Memory.html#delete_all/0","title":"Swoosh.Adapters.Local.Storage.Memory.delete_all/0","type":"function"},{"doc":"Get a specific email from the mailbox.Examplesiex&gt; email = new |&gt; from(&quot;tony.stark@example.com&quot;) %Swoosh.Email{from: {&quot;&quot;, &quot;tony.stark@example.com&quot;}, [...]} iex&gt; Memory.push(email) %Swoosh.Email{from: {&quot;&quot;, &quot;tony.stark@example.com&quot;}, headers: %{&quot;Message-ID&quot;: &quot;a1b2c3&quot;}, [...]} iex&gt; Memory.get(&quot;A1B2C3&quot;) %Swoosh.Email{from: {&quot;&quot;, &quot;tony.stark@example.com&quot;}, headers: %{&quot;Message-ID&quot;: &quot;a1b2c3&quot;}, [...]}","ref":"Swoosh.Adapters.Local.Storage.Memory.html#get/1","title":"Swoosh.Adapters.Local.Storage.Memory.get/1","type":"function"},{"doc":"Callback implementation for GenServer.init/1.","ref":"Swoosh.Adapters.Local.Storage.Memory.html#init/1","title":"Swoosh.Adapters.Local.Storage.Memory.init/1","type":"function"},{"doc":"Pop the last email from the mailbox.Examplesiex&gt; email = new |&gt; from(&quot;tony.stark@example.com&quot;) %Swoosh.Email{from: {&quot;&quot;, &quot;tony.stark@example.com&quot;}, [...]} iex&gt; Memory.push(email) %Swoosh.Email{from: {&quot;&quot;, &quot;tony.stark@example.com&quot;}, headers: %{&quot;Message-ID&quot;: &quot;a1b2c3&quot;}, [...]} iex&gt; Memory.all() |&gt; Enum.count() 1 iex&gt; Memory.pop() %Swoosh.Email{from: {&quot;&quot;, &quot;tony.stark@example.com&quot;}, headers: %{&quot;Message-ID&quot;: &quot;a1b2c3&quot;}, [...]} iex&gt; Memory.all() |&gt; Enun.count() 0","ref":"Swoosh.Adapters.Local.Storage.Memory.html#pop/0","title":"Swoosh.Adapters.Local.Storage.Memory.pop/0","type":"function"},{"doc":"Push a new email into the mailbox.In order to make it easy to fetch a single email, a Message-ID header is added to the email before being stored.Examplesiex&gt; email = new |&gt; from(&quot;tony.stark@example.com&quot;) %Swoosh.Email{from: {&quot;&quot;, &quot;tony.stark@example.com&quot;}, [...]} iex&gt; Memory.push(email) %Swoosh.Email{from: {&quot;&quot;, &quot;tony.stark@example.com&quot;}, headers: %{&quot;Message-ID&quot;: &quot;a1b2c3&quot;}, [...]}","ref":"Swoosh.Adapters.Local.Storage.Memory.html#push/1","title":"Swoosh.Adapters.Local.Storage.Memory.push/1","type":"function"},{"doc":"Starts the server","ref":"Swoosh.Adapters.Local.Storage.Memory.html#start_link/1","title":"Swoosh.Adapters.Local.Storage.Memory.start_link/1","type":"function"},{"doc":"Stops the server","ref":"Swoosh.Adapters.Local.Storage.Memory.html#stop/0","title":"Swoosh.Adapters.Local.Storage.Memory.stop/0","type":"function"},{"doc":"An adapter that only logs email using Logger.It can be useful in environment where you do not necessarily want to send real emails (eg. staging environments) or in development.By default it only prints the recipient of the email but you can print the full email by using log_full_email: true in the adapter configuration.Example# config/config.exs config :sample, Sample.Mailer, adapter: Swoosh.Adapters.Logger, level: :debug # lib/sample/mailer.ex defmodule Sample.Mailer do use Swoosh.Mailer, otp_app: :sample end","ref":"Swoosh.Adapters.Logger.html","title":"Swoosh.Adapters.Logger","type":"module"},{"doc":"Callback implementation for Swoosh.Adapter.validate_config/1.","ref":"Swoosh.Adapters.Logger.html#validate_config/1","title":"Swoosh.Adapters.Logger.validate_config/1","type":"function"},{"doc":"Callback implementation for Swoosh.Adapter.validate_dependency/0.","ref":"Swoosh.Adapters.Logger.html#validate_dependency/0","title":"Swoosh.Adapters.Logger.validate_dependency/0","type":"function"},{"doc":"An adapter that sends email using the Mailgun API.For reference: Mailgun API docsDependencyMailgun adapter requires Plug to work properly.Example# config/config.exs config :sample, Sample.Mailer, adapter: Swoosh.Adapters.Mailgun, api_key: &quot;my-api-key&quot;, domain: &quot;avengers.com&quot; # lib/sample/mailer.ex defmodule Sample.Mailer do use Swoosh.Mailer, otp_app: :sample endProvider options:custom_vars (v:):sending_options (o:):template_name (template):recipient_vars (recipient-variables):tags (o:tag, added before :sending_options)Custom headersHeaders added via Email.header/3 will be translated to (h:) values that Mailgun recognizes.","ref":"Swoosh.Adapters.Mailgun.html","title":"Swoosh.Adapters.Mailgun","type":"module"},{"doc":"Callback implementation for Swoosh.Adapter.validate_config/1.","ref":"Swoosh.Adapters.Mailgun.html#validate_config/1","title":"Swoosh.Adapters.Mailgun.validate_config/1","type":"function"},{"doc":"Callback implementation for Swoosh.Adapter.validate_dependency/0.","ref":"Swoosh.Adapters.Mailgun.html#validate_dependency/0","title":"Swoosh.Adapters.Mailgun.validate_dependency/0","type":"function"},{"doc":"An adapter that sends email using the Mailjet API.For reference: Mailjet API docsDependencyMailjet adapter requires Plug to work properly.Example# config/config.exs config :sample, Sample.Mailer, adapter: Swoosh.Adapters.Mailjet, api_key: &quot;my-api-key&quot;, secret: &quot;my-secret-key&quot; # lib/sample/mailer.ex defmodule Sample.Mailer do use Swoosh.Mailer, otp_app: :sample end","ref":"Swoosh.Adapters.Mailjet.html","title":"Swoosh.Adapters.Mailjet","type":"module"},{"doc":"Callback implementation for Swoosh.Adapter.validate_config/1.","ref":"Swoosh.Adapters.Mailjet.html#validate_config/1","title":"Swoosh.Adapters.Mailjet.validate_config/1","type":"function"},{"doc":"Callback implementation for Swoosh.Adapter.validate_dependency/0.","ref":"Swoosh.Adapters.Mailjet.html#validate_dependency/0","title":"Swoosh.Adapters.Mailjet.validate_dependency/0","type":"function"},{"doc":"An adapter that sends email using the Mandrill API.It supports both the send and send-template endpoint. In order to use the latter you need to set template_name in the provider_options map on Swoosh.Email.For reference: Mandrill API docsExample# config/config.exs config :sample, Sample.Mailer, adapter: Swoosh.Adapters.Mandrill, api_key: &quot;my-api-key&quot; # lib/sample/mailer.ex defmodule Sample.Mailer do use Swoosh.Mailer, otp_app: :sample endExample of using the send-template endpointimport Swoosh.Email new() |&gt; from({&quot;T Stark&quot;, &quot;tony.stark@example.com&quot;}) |&gt; to({&quot;Steve Rogers&quot;, &quot;steve.rogers@example.com&quot;}) |&gt; subject(&quot;Hello, Avengers!&quot;) |&gt; put_provider_option(:template_name, &quot;welcome&quot;) |&gt; put_provider_option(:template_content, [%{&quot;name&quot; =&gt; &quot;START_DATE&quot;, &quot;content&quot; =&gt; &quot;Next Monday&quot;}])","ref":"Swoosh.Adapters.Mandrill.html","title":"Swoosh.Adapters.Mandrill","type":"module"},{"doc":"Callback implementation for Swoosh.Adapter.validate_config/1.","ref":"Swoosh.Adapters.Mandrill.html#validate_config/1","title":"Swoosh.Adapters.Mandrill.validate_config/1","type":"function"},{"doc":"Callback implementation for Swoosh.Adapter.validate_dependency/0.","ref":"Swoosh.Adapters.Mandrill.html#validate_dependency/0","title":"Swoosh.Adapters.Mandrill.validate_dependency/0","type":"function"},{"doc":"An adapter that sends email using the Postmark API.For reference: Postmark API docsExample# config/config.exs config :sample, Sample.Mailer, adapter: Swoosh.Adapters.Postmark, api_key: &quot;my-api-key&quot; # lib/sample/mailer.ex defmodule Sample.Mailer do use Swoosh.Mailer, otp_app: :sample endExample of sending emails using templatesThis will use Postmark's withTemplate endpoint.import Swoosh.Email new() |&gt; from({&quot;T Stark&quot;, &quot;tony.stark@example.com&quot;}) |&gt; to({&quot;Steve Rogers&quot;, &quot;steve.rogers@example.com&quot;}) |&gt; subject(&quot;Hello, Avengers!&quot;) |&gt; put_provider_option(:template_id, &quot;123456&quot;) |&gt; put_provider_option(:template_model, %{name: &quot;Steve&quot;, email: &quot;steve@avengers.com&quot;})You can also use template_alias instead of template_id, if you use Postmark's TemplateAlias feature.Example of sending emails with a tagThis will add a tag to the sent Postmark's email.import Swoosh.Email new() |&gt; from({&quot;T Stark&quot;, &quot;tony.stark@example.com&quot;}) |&gt; to({&quot;Steve Rogers&quot;, &quot;steve.rogers@example.com&quot;}) |&gt; subject(&quot;Hello, Avengers!&quot;) |&gt; put_provider_option(:tag, &quot;some tag&quot;)","ref":"Swoosh.Adapters.Postmark.html","title":"Swoosh.Adapters.Postmark","type":"module"},{"doc":"Callback implementation for Swoosh.Adapter.validate_config/1.","ref":"Swoosh.Adapters.Postmark.html#validate_config/1","title":"Swoosh.Adapters.Postmark.validate_config/1","type":"function"},{"doc":"Callback implementation for Swoosh.Adapter.validate_dependency/0.","ref":"Swoosh.Adapters.Postmark.html#validate_dependency/0","title":"Swoosh.Adapters.Postmark.validate_dependency/0","type":"function"},{"doc":"An adapter that sends email using the SMTP protocol.Underneath this adapter uses the gen_smtp library.Example# mix.exs def application do [applications: [:swoosh, :gen_smtp]] end # config/config.exs config :sample, Sample.Mailer, adapter: Swoosh.Adapters.SMTP, relay: &quot;smtp.avengers.com&quot;, username: &quot;tonystark&quot;, password: &quot;ilovepepperpotts&quot;, ssl: true, tls: :always, auth: :always, port: 1025, dkim: [ s: &quot;default&quot;, d: &quot;domain.com&quot;, private_key: {:pem_plain, File.read!(&quot;priv/keys/domain.private&quot;)} ], retries: 2, no_mx_lookups: false # lib/sample/mailer.ex defmodule Sample.Mailer do use Swoosh.Mailer, otp_app: :sample end","ref":"Swoosh.Adapters.SMTP.html","title":"Swoosh.Adapters.SMTP","type":"module"},{"doc":"","ref":"Swoosh.Adapters.SMTP.html#gen_smtp_config/1","title":"Swoosh.Adapters.SMTP.gen_smtp_config/1","type":"function"},{"doc":"Callback implementation for Swoosh.Adapter.validate_config/1.","ref":"Swoosh.Adapters.SMTP.html#validate_config/1","title":"Swoosh.Adapters.SMTP.validate_config/1","type":"function"},{"doc":"Callback implementation for Swoosh.Adapter.validate_dependency/0.","ref":"Swoosh.Adapters.SMTP.html#validate_dependency/0","title":"Swoosh.Adapters.SMTP.validate_dependency/0","type":"function"},{"doc":"An adapter that sends email using the Sendgrid API.For reference: Sendgrid API docsExample# config/config.exs config :sample, Sample.Mailer, adapter: Swoosh.Adapters.Sendgrid, api_key: &quot;my-api-key&quot; # lib/sample/mailer.ex defmodule Sample.Mailer do use Swoosh.Mailer, otp_app: :sample endSandbox modeFor sandbox mode, use put_provider_option/3:iex&gt; new() |&gt; put_provider_option(:mail_settings, %{sandbox_mode: %{enable: true}})","ref":"Swoosh.Adapters.Sendgrid.html","title":"Swoosh.Adapters.Sendgrid","type":"module"},{"doc":"Callback implementation for Swoosh.Adapter.validate_config/1.","ref":"Swoosh.Adapters.Sendgrid.html#validate_config/1","title":"Swoosh.Adapters.Sendgrid.validate_config/1","type":"function"},{"doc":"Callback implementation for Swoosh.Adapter.validate_dependency/0.","ref":"Swoosh.Adapters.Sendgrid.html#validate_dependency/0","title":"Swoosh.Adapters.Sendgrid.validate_dependency/0","type":"function"},{"doc":"An adapter that sends email using the sendmail binary.Example# config/config.exs config :sample, Sample.Mailer, adapter: Swoosh.Adapters.Sendmail, cmd_path: &quot;/usr/bin/sendmail&quot;, cmd_args: &quot;-N delay,failure,success&quot;, qmail: true # Default false # lib/sample/mailer.ex defmodule Sample.Mailer do use Swoosh.Mailer, otp_app: :sample end","ref":"Swoosh.Adapters.Sendmail.html","title":"Swoosh.Adapters.Sendmail","type":"module"},{"doc":"Callback implementation for Swoosh.Adapter.validate_config/1.","ref":"Swoosh.Adapters.Sendmail.html#validate_config/1","title":"Swoosh.Adapters.Sendmail.validate_config/1","type":"function"},{"doc":"Callback implementation for Swoosh.Adapter.validate_dependency/0.","ref":"Swoosh.Adapters.Sendmail.html#validate_dependency/0","title":"Swoosh.Adapters.Sendmail.validate_dependency/0","type":"function"},{"doc":"An adapter that sends email using the SocketLabs Injection API.For reference: [SocketLabs API docs](https://inject.docs.socketlabs.com/v1/documentation/introductionExample# config/congig.exs config :sample, Smaple.Mailer adapter: Swoosh.Adapters.SocketLabs, server_id: &quot;&quot;, api_key: &quot;&quot; # lib/sample/mailer.ex defmodule Sample.Mailer do use Swoosh.Mailer, otp_app: :sample end","ref":"Swoosh.Adapters.SocketLabs.html","title":"Swoosh.Adapters.SocketLabs","type":"module"},{"doc":"Callback implementation for Swoosh.Adapter.validate_config/1.","ref":"Swoosh.Adapters.SocketLabs.html#validate_config/1","title":"Swoosh.Adapters.SocketLabs.validate_config/1","type":"function"},{"doc":"Callback implementation for Swoosh.Adapter.validate_dependency/0.","ref":"Swoosh.Adapters.SocketLabs.html#validate_dependency/0","title":"Swoosh.Adapters.SocketLabs.validate_dependency/0","type":"function"},{"doc":"An adapter that sends email using the SparkPost API.For reference: SparkPost API docsExample# config/config.exs config :sample, Sample.Mailer, adapter: Swoosh.Adapters.SparkPost, api_key: &quot;my-api-key&quot;, endpoint: &quot;https://api.sparkpost.com/api/v1&quot; # or &quot;https://YOUR_DOMAIN.sparkpostelite.com/api/v1&quot; for enterprise # lib/sample/mailer.ex defmodule Sample.Mailer do use Swoosh.Mailer, otp_app: :sample endUsing with SparkPost templatesimport Swoosh.Email new() |&gt; from(&quot;tony.stark@example.com&quot;) |&gt; to(&quot;steve.rogers@example.com&quot;) |&gt; subject(&quot;Hello, Avengers!&quot;) |&gt; put_provider_option(:template_id, &quot;my-first-email&quot;) |&gt; put_provider_option(:substitution_data, %{ first_name: &quot;Peter&quot;, last_name: &quot;Parker&quot; })Setting SparkPost transmission optionsFull options can be found at SparkPost Transmissions API Docsimport Swoosh.Email new() |&gt; from(&quot;tony.stark@example.com&quot;) |&gt; to(&quot;steve.rogers@example.com&quot;) |&gt; subject(&quot;Hello, Avengers!&quot;) |&gt; put_provider_option(:options, %{ click_tracking: false, open_tracking: false, transactional: true, inline_css: true })","ref":"Swoosh.Adapters.SparkPost.html","title":"Swoosh.Adapters.SparkPost","type":"module"},{"doc":"Callback implementation for Swoosh.Adapter.validate_config/1.","ref":"Swoosh.Adapters.SparkPost.html#validate_config/1","title":"Swoosh.Adapters.SparkPost.validate_config/1","type":"function"},{"doc":"Callback implementation for Swoosh.Adapter.validate_dependency/0.","ref":"Swoosh.Adapters.SparkPost.html#validate_dependency/0","title":"Swoosh.Adapters.SparkPost.validate_dependency/0","type":"function"},{"doc":"An adapter that sends emails as messages to the current process.This is meant to be used during tests and works with the assertions found in the Swoosh.TestAssertions module.Example# config/test.exs config :sample, Sample.Mailer, adapter: Swoosh.Adapters.Test # lib/sample/mailer.ex defmodule Sample.Mailer do use Swoosh.Mailer, otp_app: :sample end","ref":"Swoosh.Adapters.Test.html","title":"Swoosh.Adapters.Test","type":"module"},{"doc":"Callback implementation for Swoosh.Adapter.validate_config/1.","ref":"Swoosh.Adapters.Test.html#validate_config/1","title":"Swoosh.Adapters.Test.validate_config/1","type":"function"},{"doc":"Callback implementation for Swoosh.Adapter.validate_dependency/0.","ref":"Swoosh.Adapters.Test.html#validate_dependency/0","title":"Swoosh.Adapters.Test.validate_dependency/0","type":"function"},{"doc":"Specification for a Swoosh API client.It can be set to your own client with:config :swoosh, :api_client, MyAPIClient","ref":"Swoosh.ApiClient.html","title":"Swoosh.ApiClient","type":"behaviour"},{"doc":"Callback to initializes the given api client.","ref":"Swoosh.ApiClient.html#c:init/0","title":"Swoosh.ApiClient.init/0","type":"callback"},{"doc":"API used by adapters to post to a given URL with headers, body, and e-mail.","ref":"Swoosh.ApiClient.html#post/4","title":"Swoosh.ApiClient.post/4","type":"function"},{"doc":"Callback invoked when posting to a given URL.","ref":"Swoosh.ApiClient.html#c:post/4","title":"Swoosh.ApiClient.post/4","type":"callback"},{"doc":"","ref":"Swoosh.ApiClient.html#t:body/0","title":"Swoosh.ApiClient.body/0","type":"type"},{"doc":"","ref":"Swoosh.ApiClient.html#t:headers/0","title":"Swoosh.ApiClient.headers/0","type":"type"},{"doc":"","ref":"Swoosh.ApiClient.html#t:status/0","title":"Swoosh.ApiClient.status/0","type":"type"},{"doc":"","ref":"Swoosh.ApiClient.html#t:url/0","title":"Swoosh.ApiClient.url/0","type":"type"},{"doc":"Built-in hackney-based ApiClient.","ref":"Swoosh.ApiClient.Hackney.html","title":"Swoosh.ApiClient.Hackney","type":"module"},{"doc":"","ref":"Swoosh.Application.html","title":"Swoosh.Application","type":"module"},{"doc":"Callback implementation for Application.start/2.","ref":"Swoosh.Application.html#start/2","title":"Swoosh.Application.start/2","type":"function"},{"doc":"Struct representing an attachment in an email.","ref":"Swoosh.Attachment.html","title":"Swoosh.Attachment","type":"module"},{"doc":"","ref":"Swoosh.Attachment.html#get_content/1","title":"Swoosh.Attachment.get_content/1","type":"function"},{"doc":"","ref":"Swoosh.Attachment.html#get_content/2","title":"Swoosh.Attachment.get_content/2","type":"function"},{"doc":"Creates a new AttachmentExamples:Attachment.new(&quot;/path/to/attachment.png&quot;) Attachment.new(&quot;/path/to/attachment.png&quot;, filename: &quot;image.png&quot;) Attachment.new(&quot;/path/to/attachment.png&quot;, filename: &quot;image.png&quot;, content_type: &quot;image/png&quot;) Attachment.new(params[&quot;file&quot;]) # Where params[&quot;file&quot;] is a %Plug.UploadExamples with inline-attachments:Attachment.new(&quot;/path/to/attachment.png&quot;, type: :inline) Attachment.new(&quot;/path/to/attachment.png&quot;, filename: &quot;image.png&quot;, type: :inline) Attachment.new(&quot;/path/to/attachment.png&quot;, filename: &quot;image.png&quot;, content_type: &quot;image/png&quot;, type: :inline) Attachment.new(params[&quot;file&quot;], type: &quot;inline&quot;) # Where params[&quot;file&quot;] is a %Plug.Upload Attachment.new({:data, File.read!(&quot;/path/to/attachment.png&quot;)}, filename: &quot;image.png&quot;, content_type: &quot;image/png&quot;, type: :inline)","ref":"Swoosh.Attachment.html#new/2","title":"Swoosh.Attachment.new/2","type":"function"},{"doc":"","ref":"Swoosh.Attachment.html#t:content_encoding/0","title":"Swoosh.Attachment.content_encoding/0","type":"type"},{"doc":"","ref":"Swoosh.Attachment.html#t:t/0","title":"Swoosh.Attachment.t/0","type":"type"},{"doc":"Defines an Email.This module defines a Swoosh.Email struct and the main functions for composing an email. As it is the contract for the public APIs of Swoosh it is a good idea to make use of these functions rather than build the struct yourself.Email fieldsfrom - the email address of the sender, example: {&quot;Tony Stark&quot;, &quot;tony.stark@example.com&quot;}to - the email address for the recipient(s), example: [{&quot;Steve Rogers&quot;, &quot;steve.rogers@example.com&quot;}]subject - the subject of the email, example: &quot;Hello, Avengers!&quot;cc - the intended carbon copy recipient(s) of the email, example: [{&quot;Bruce Banner&quot;, &quot;hulk.smash@example.com&quot;}]bcc - the intended blind carbon copy recipient(s) of the email, example: [{&quot;Janet Pym&quot;, &quot;wasp.avengers@example.com&quot;}]text_body - the content of the email in plaintext, example: &quot;Hello&quot;html_body - the content of the email in HTML, example: &quot;&lt;h1&gt;Hello&lt;/h1&gt;&quot;reply_to - the email address that should receive replies, example: {&quot;Clint Barton&quot;, &quot;hawk.eye@example.com&quot;}headers - a map of headers that should be included in the email, example: %{&quot;X-Accept-Language&quot; =&gt; &quot;en-us, en&quot;}attachments - a list of attachments that should be included in the email, example: [%{path: &quot;/data/uuid-random&quot;, filename: &quot;att.zip&quot;, content_type: &quot;application/zip&quot;}]assigns - a map of values that correspond with any template variables, example: %{&quot;first_name&quot; =&gt; &quot;Bruce&quot;}PrivateThis key is reserved for use with adapters, libraries and frameworks.private - a map of values that are for use by libraries/frameworks, example: %{phoenix_template: &quot;welcome.html.eex&quot;}hackney_options will be passed to underlining hackney post callProvider optionsThis key allow users to make use of provider-specific functionality by passing along addition parameters.provider_options - a map of values that are specific to adapter provider, example: %{async: true}Examplesemail = new() |&gt; to(&quot;tony.stark@example.com&quot;) |&gt; from(&quot;bruce.banner@example.com&quot;) |&gt; text_body(&quot;Welcome to the Avengers&quot;)The composable nature makes it very easy to continue expanding upon a given Email.email = email |&gt; cc({&quot;Steve Rogers&quot;, &quot;steve.rogers@example.com&quot;}) |&gt; cc(&quot;wasp.avengers@example.com&quot;) |&gt; bcc([&quot;thor.odinson@example.com&quot;, {&quot;Henry McCoy&quot;, &quot;beast.avengers@example.com&quot;}]) |&gt; html_body(&quot;&lt;h1&gt;Special Welcome&lt;/h1&gt;&quot;)You can also directly pass arguments to the new/1 function.email = new(from: &quot;tony.stark@example.com&quot;, to: &quot;steve.rogers@example.com&quot;, subject: &quot;Hello, Avengers!&quot;)","ref":"Swoosh.Email.html","title":"Swoosh.Email","type":"module"},{"doc":"Stores a new variable key and value in the email.This store is meant for variables used in templating. The name should be specified as an atom, the value can be any term.Examplesiex&gt; new() |&gt; assign(:username, &quot;ironman&quot;) %Swoosh.Email{assigns: %{username: &quot;ironman&quot;}, attachments: [], bcc: [], cc: [], from: nil, headers: %{}, html_body: nil, private: %{}, provider_options: %{}, reply_to: nil, subject: &quot;&quot;, text_body: nil, to: []}","ref":"Swoosh.Email.html#assign/3","title":"Swoosh.Email.assign/3","type":"function"},{"doc":"Add a new attachment in the email.You can pass the path to a file, a Swoosh.Attachment or a %Plug.Upload{} struct as an argument. If you give a path we will detect the MIME type and determine the filename automatically.You can also send an inline-attachment used for embedding images in the body of emails by specifying type: :inlineExamplesiex&gt; new() |&gt; attachment(&quot;/data/att.zip&quot;) %Swoosh.Email{assigns: %{}, bcc: [], cc: [], from: nil, headers: %{}, html_body: nil, private: %{}, provider_options: %{}, reply_to: nil, subject: &quot;&quot;, text_body: nil, to: [], attachments: [%Swoosh.Attachment{path: &quot;/data/att.zip&quot;, content_type: &quot;application/zip&quot;, filename: &quot;att.zip&quot;, type: :attachment, data: nil, headers: []}]} iex&gt; new() |&gt; attachment(Swoosh.Attachment.new(&quot;/data/att.zip&quot;)) %Swoosh.Email{assigns: %{}, bcc: [], cc: [], from: nil, headers: %{}, html_body: nil, private: %{}, provider_options: %{}, reply_to: nil, subject: &quot;&quot;, text_body: nil, to: [], attachments: [%Swoosh.Attachment{path: &quot;/data/att.zip&quot;, content_type: &quot;application/zip&quot;, filename: &quot;att.zip&quot;, type: :attachment, data: nil, headers: []}]} iex&gt; new() |&gt; attachment(%Plug.Upload{path: &quot;/data/abcdefg&quot;, content_type: &quot;test/type&quot;, filename: &quot;att.zip&quot;}) %Swoosh.Email{assigns: %{}, bcc: [], cc: [], from: nil, headers: %{}, html_body: nil, private: %{}, provider_options: %{}, reply_to: nil, subject: &quot;&quot;, text_body: nil, to: [], attachments: [%Swoosh.Attachment{path: &quot;/data/abcdefg&quot;, content_type: &quot;test/type&quot;, filename: &quot;att.zip&quot;, type: :attachment, data: nil, headers: []}]} iex&gt; new() |&gt; attachment(Swoosh.Attachment.new(&quot;/data/att.png&quot;, type: :inline)) %Swoosh.Email{assigns: %{}, bcc: [], cc: [], from: nil, headers: %{}, html_body: nil, private: %{}, provider_options: %{}, reply_to: nil, subject: &quot;&quot;, text_body: nil, to: [], attachments: [%Swoosh.Attachment{path: &quot;/data/att.png&quot;, content_type: &quot;image/png&quot;, filename: &quot;att.png&quot;, type: :inline, data: nil, headers: []}]}","ref":"Swoosh.Email.html#attachment/2","title":"Swoosh.Email.attachment/2","type":"function"},{"doc":"Adds new recipients in the bcc field.The recipient must be; a tuple specifying the name and address of the recipient; a string specifying the address of the recipient; or an array comprised of a combination of either.iex&gt; new() |&gt; bcc(&quot;steve.rogers@example.com&quot;) %Swoosh.Email{assigns: %{}, attachments: [], bcc: [{&quot;&quot;, &quot;steve.rogers@example.com&quot;}], cc: [], from: nil, headers: %{}, html_body: nil, private: %{}, provider_options: %{}, reply_to: nil, subject: &quot;&quot;, text_body: nil, to: []}","ref":"Swoosh.Email.html#bcc/2","title":"Swoosh.Email.bcc/2","type":"function"},{"doc":"Adds new recipients in the cc field.The recipient must be; a tuple specifying the name and address of the recipient; a string specifying the address of the recipient; or an array comprised of a combination of either.Examplesiex&gt; new() |&gt; cc(&quot;steve.rogers@example.com&quot;) %Swoosh.Email{assigns: %{}, attachments: [], bcc: [], cc: [{&quot;&quot;, &quot;steve.rogers@example.com&quot;}], from: nil, headers: %{}, html_body: nil, private: %{}, provider_options: %{}, reply_to: nil, subject: &quot;&quot;, text_body: nil, to: []}","ref":"Swoosh.Email.html#cc/2","title":"Swoosh.Email.cc/2","type":"function"},{"doc":"Sets a recipient in the from field.The recipient must be either; a tuple specifying the name and address of the recipient; a string specifying the address of the recipient.Examplesiex&gt; new() |&gt; from({&quot;Steve Rogers&quot;, &quot;steve.rogers@example.com&quot;}) %Swoosh.Email{assigns: %{}, attachments: [], bcc: [], cc: [], from: {&quot;Steve Rogers&quot;, &quot;steve.rogers@example.com&quot;}, headers: %{}, html_body: nil, private: %{}, provider_options: %{}, reply_to: nil, subject: &quot;&quot;, text_body: nil, to: []} iex&gt; new() |&gt; from(&quot;steve.rogers@example.com&quot;) %Swoosh.Email{assigns: %{}, attachments: [], bcc: [], cc: [], from: {&quot;&quot;, &quot;steve.rogers@example.com&quot;}, headers: %{}, html_body: nil, private: %{}, provider_options: %{}, reply_to: nil, subject: &quot;&quot;, text_body: nil, to: []}","ref":"Swoosh.Email.html#from/2","title":"Swoosh.Email.from/2","type":"function"},{"doc":"Adds a new header in the email.The name and value must be specified as strings.Examplesiex&gt; new() |&gt; header(&quot;X-Magic-Number&quot;, &quot;7&quot;) %Swoosh.Email{assigns: %{}, attachments: [], bcc: [], cc: [], from: nil, headers: %{&quot;X-Magic-Number&quot; =&gt; &quot;7&quot;}, html_body: nil, private: %{}, provider_options: %{}, reply_to: nil, subject: &quot;&quot;, text_body: nil, to: []}","ref":"Swoosh.Email.html#header/3","title":"Swoosh.Email.header/3","type":"function"},{"doc":"Sets the html_body field.The HTML body must be a string that containing the HTML content.Examplesiex&gt; new() |&gt; html_body(&quot;&lt;h1&gt;Hello&lt;/h1&gt;&quot;) %Swoosh.Email{assigns: %{}, attachments: [], bcc: [], cc: [], from: nil, headers: %{}, html_body: &quot;&lt;h1&gt;Hello&lt;/h1&gt;&quot;, private: %{}, provider_options: %{}, reply_to: nil, subject: &quot;&quot;, text_body: nil, to: []}","ref":"Swoosh.Email.html#html_body/2","title":"Swoosh.Email.html_body/2","type":"function"},{"doc":"Returns a Swoosh.Email struct.You can pass a keyword list or a map argument to the function that will be used to populate the fields of that struct. Note that it will silently ignore any fields that it doesn't know about.Examplesiex&gt; new() %Swoosh.Email{} iex&gt; new(subject: &quot;Hello, Avengers!&quot;) %Swoosh.Email{subject: &quot;Hello, Avengers!&quot;} iex&gt; new(from: &quot;tony.stark@example.com&quot;) %Swoosh.Email{from: {&quot;&quot;, &quot;tony.stark@example.com&quot;}} iex&gt; new(from: {&quot;Tony Stark&quot;, &quot;tony.stark@example.com&quot;}) %Swoosh.Email{from: {&quot;Tony Stark&quot;, &quot;tony.stark@example.com&quot;}} iex&gt; new(to: &quot;steve.rogers@example.com&quot;) %Swoosh.Email{to: [{&quot;&quot;, &quot;steve.rogers@example.com&quot;}]} iex&gt; new(to: {&quot;Steve Rogers&quot;, &quot;steve.rogers@example.com&quot;}) %Swoosh.Email{to: [{&quot;Steve Rogers&quot;, &quot;steve.rogers@example.com&quot;}]} iex&gt; new(to: [{&quot;Bruce Banner&quot;, &quot;bruce.banner@example.com&quot;}, &quot;thor.odinson@example.com&quot;]) %Swoosh.Email{to: [{&quot;Bruce Banner&quot;, &quot;bruce.banner@example.com&quot;}, {&quot;&quot;, &quot;thor.odinson@example.com&quot;}]} iex&gt; new(cc: &quot;steve.rogers@example.com&quot;) %Swoosh.Email{cc: [{&quot;&quot;, &quot;steve.rogers@example.com&quot;}]} iex&gt; new(cc: {&quot;Steve Rogers&quot;, &quot;steve.rogers@example.com&quot;}) %Swoosh.Email{cc: [{&quot;Steve Rogers&quot;, &quot;steve.rogers@example.com&quot;}]} iex&gt; new(cc: [{&quot;Bruce Banner&quot;, &quot;bruce.banner@example.com&quot;}, &quot;thor.odinson@example.com&quot;]) %Swoosh.Email{cc: [{&quot;Bruce Banner&quot;, &quot;bruce.banner@example.com&quot;}, {&quot;&quot;, &quot;thor.odinson@example.com&quot;}]} iex&gt; new(bcc: &quot;steve.rogers@example.com&quot;) %Swoosh.Email{bcc: [{&quot;&quot;, &quot;steve.rogers@example.com&quot;}]} iex&gt; new(bcc: {&quot;Steve Rogers&quot;, &quot;steve.rogers@example.com&quot;}) %Swoosh.Email{bcc: [{&quot;Steve Rogers&quot;, &quot;steve.rogers@example.com&quot;}]} iex&gt; new(bcc: [{&quot;Bruce Banner&quot;, &quot;bruce.banner@example.com&quot;}, &quot;thor.odinson@example.com&quot;]) %Swoosh.Email{bcc: [{&quot;Bruce Banner&quot;, &quot;bruce.banner@example.com&quot;}, {&quot;&quot;, &quot;thor.odinson@example.com&quot;}]} iex&gt; new(html_body: &quot;&lt;h1&gt;Welcome, Avengers&lt;/h1&gt;&quot;) %Swoosh.Email{html_body: &quot;&lt;h1&gt;Welcome, Avengers&lt;/h1&gt;&quot;} iex&gt; new(text_body: &quot;Welcome, Avengers&quot;) %Swoosh.Email{text_body: &quot;Welcome, Avengers&quot;} iex&gt; new(reply_to: &quot;edwin.jarvis@example.com&quot;) %Swoosh.Email{reply_to: {&quot;&quot;, &quot;edwin.jarvis@example.com&quot;}} iex&gt; new(reply_to: {&quot;Edwin Jarvis&quot;, &quot;edwin.jarvis@example.com&quot;}) %Swoosh.Email{reply_to: {&quot;Edwin Jarvis&quot;, &quot;edwin.jarvis@example.com&quot;}} iex&gt; new(headers: %{&quot;X-Accept-Language&quot; =&gt; &quot;en&quot;}) %Swoosh.Email{headers: %{&quot;X-Accept-Language&quot; =&gt; &quot;en&quot;}} iex&gt; new(assigns: %{user_id: 10}) %Swoosh.Email{assigns: %{user_id: 10}} iex&gt; new(provider_options: %{async: true}) %Swoosh.Email{provider_options: %{async: true}}You can obviously combine these arguments together:iex&gt; new(to: &quot;steve.rogers@example.com&quot;, subject: &quot;Hello, Avengers!&quot;) %Swoosh.Email{to: [{&quot;&quot;, &quot;steve.rogers@example.com&quot;}], subject: &quot;Hello, Avengers!&quot;}","ref":"Swoosh.Email.html#new/1","title":"Swoosh.Email.new/1","type":"function"},{"doc":"Puts new recipients in the bcc field.It will replace any previously added bcc recipients.","ref":"Swoosh.Email.html#put_bcc/2","title":"Swoosh.Email.put_bcc/2","type":"function"},{"doc":"Puts new recipients in the cc field.It will replace any previously added cc recipients.","ref":"Swoosh.Email.html#put_cc/2","title":"Swoosh.Email.put_cc/2","type":"function"},{"doc":"Stores a new private key and value in the email.This store is meant to be for libraries/framework usage. The name should be specified as an atom, the value can be any term.Examplesiex&gt; new() |&gt; put_private(:phoenix_template, &quot;welcome.html&quot;) %Swoosh.Email{assigns: %{}, attachments: [], bcc: [], cc: [], from: nil, headers: %{}, html_body: nil, private: %{phoenix_template: &quot;welcome.html&quot;}, provider_options: %{}, reply_to: nil, subject: &quot;&quot;, text_body: nil, to: []}","ref":"Swoosh.Email.html#put_private/3","title":"Swoosh.Email.put_private/3","type":"function"},{"doc":"Stores a new provider_option key and value in the email.This store is meant for adapter usage, to aid provider-specific functionality. The name should be specified as an atom, the value can be any term.Examplesiex&gt; new() |&gt; put_provider_option(:async, true) %Swoosh.Email{assigns: %{}, attachments: [], bcc: [], cc: [], from: nil, headers: %{}, html_body: nil, private: %{}, provider_options: %{async: true}, reply_to: nil, subject: &quot;&quot;, text_body: nil, to: []}","ref":"Swoosh.Email.html#put_provider_option/3","title":"Swoosh.Email.put_provider_option/3","type":"function"},{"doc":"Puts new recipients in the to field.It will replace any previously added to recipients.","ref":"Swoosh.Email.html#put_to/2","title":"Swoosh.Email.put_to/2","type":"function"},{"doc":"Sets a recipient in the reply_to field.The recipient must be either; a tuple specifying the name and address of the recipient; a string specifying the address of the recipient.Examplesiex&gt; new() |&gt; reply_to({&quot;Steve Rogers&quot;, &quot;steve.rogers@example.com&quot;}) %Swoosh.Email{assigns: %{}, attachments: [], bcc: [], cc: [], from: nil, headers: %{}, html_body: nil, private: %{}, provider_options: %{}, reply_to: {&quot;Steve Rogers&quot;, &quot;steve.rogers@example.com&quot;}, subject: &quot;&quot;, text_body: nil, to: []} iex&gt; new() |&gt; reply_to(&quot;steve.rogers@example.com&quot;) %Swoosh.Email{assigns: %{}, attachments: [], bcc: [], cc: [], from: nil, headers: %{}, html_body: nil, private: %{}, provider_options: %{}, reply_to: {&quot;&quot;, &quot;steve.rogers@example.com&quot;}, subject: &quot;&quot;, text_body: nil, to: []}","ref":"Swoosh.Email.html#reply_to/2","title":"Swoosh.Email.reply_to/2","type":"function"},{"doc":"Sets the subject field.The subject must be a string that contains the subject.Examplesiex&gt; new() |&gt; subject(&quot;Hello, Avengers!&quot;) %Swoosh.Email{assigns: %{}, attachments: [], bcc: [], cc: [], from: nil, headers: %{}, html_body: nil, private: %{}, provider_options: %{}, reply_to: nil, subject: &quot;Hello, Avengers!&quot;, text_body: nil, to: []}","ref":"Swoosh.Email.html#subject/2","title":"Swoosh.Email.subject/2","type":"function"},{"doc":"Sets the text_body field.The text body must be a string that containing the plaintext content.Examplesiex&gt; new() |&gt; text_body(&quot;Hello&quot;) %Swoosh.Email{assigns: %{}, attachments: [], bcc: [], cc: [], from: nil, headers: %{}, html_body: nil, private: %{}, provider_options: %{}, reply_to: nil, subject: &quot;&quot;, text_body: &quot;Hello&quot;, to: []}","ref":"Swoosh.Email.html#text_body/2","title":"Swoosh.Email.text_body/2","type":"function"},{"doc":"Adds new recipients in the to field.The recipient must be; a tuple specifying the name and address of the recipient; a string specifying the address of the recipient; or an array comprised of a combination of either.Examplesiex&gt; new() |&gt; to(&quot;steve.rogers@example.com&quot;) %Swoosh.Email{assigns: %{}, attachments: [], bcc: [], cc: [], from: nil, headers: %{}, html_body: nil, private: %{}, provider_options: %{}, reply_to: nil, subject: &quot;&quot;, text_body: nil, to: [{&quot;&quot;, &quot;steve.rogers@example.com&quot;}]}","ref":"Swoosh.Email.html#to/2","title":"Swoosh.Email.to/2","type":"function"},{"doc":"","ref":"Swoosh.Email.html#t:address/0","title":"Swoosh.Email.address/0","type":"type"},{"doc":"","ref":"Swoosh.Email.html#t:html_body/0","title":"Swoosh.Email.html_body/0","type":"type"},{"doc":"","ref":"Swoosh.Email.html#t:mailbox/0","title":"Swoosh.Email.mailbox/0","type":"type"},{"doc":"","ref":"Swoosh.Email.html#t:name/0","title":"Swoosh.Email.name/0","type":"type"},{"doc":"","ref":"Swoosh.Email.html#t:subject/0","title":"Swoosh.Email.subject/0","type":"type"},{"doc":"","ref":"Swoosh.Email.html#t:t/0","title":"Swoosh.Email.t/0","type":"type"},{"doc":"","ref":"Swoosh.Email.html#t:text_body/0","title":"Swoosh.Email.text_body/0","type":"type"},{"doc":"Defines a mailer.A mailer is a wrapper around an adapter that makes it easy for you to swap the adapter without having to change your code.It is also responsible for doing some sanity checks before handing down the email to the adapter.When used, the mailer expects :otp_app as an option. The :otp_app should point to an OTP application that has the mailer configuration. For example, the mailer:defmodule Sample.Mailer do use Swoosh.Mailer, otp_app: :sample endCould be configured with:config :sample, Sample.Mailer, adapter: Swoosh.Adapters.Sendgrid, api_key: &quot;SG.x.x&quot;Most of the configuration that goes into the config is specific to the adapter, so check the adapter's documentation for more information.Per module configuration is also supported, it has priority over mix configs:defmodule Sample.Mailer do use Swoosh.Mailer, otp_app: :sample, adapter: Swoosh.Adapters.Sendgrid, api_key: &quot;SG.x.x&quot; endSystem environment variables can be specified with {:system, &quot;ENV_VAR_NAME&quot;}:config :sample, Sample.Mailer, adapter: Swoosh.Adapters.SMTP, relay: &quot;smtp.sendgrid.net&quot; username: {:system, &quot;SMTP_USERNAME&quot;}, password: {:system, &quot;SMTP_PASSWORD&quot;}, tls: :alwaysExamplesOnce configured you can use your mailer like this:# in an IEx console iex&gt; email = new |&gt; from(&quot;tony.stark@example.com&quot;) |&gt; to(&quot;steve.rogers@example.com&quot;) %Swoosh.Email{from: {&quot;&quot;, &quot;tony.stark@example.com&quot;}, ...} iex&gt; Mailer.deliver(email) :okYou can also pass an extra config argument to deliver/2 that will be merged with your Mailer's config:# in an IEx console iex&gt; email = new |&gt; from(&quot;tony.stark@example.com&quot;) |&gt; to(&quot;steve.rogers@example.com&quot;) %Swoosh.Email{from: {&quot;&quot;, &quot;tony.stark@example.com&quot;}, ...} iex&gt; Mailer.deliver(email, domain: &quot;jarvis.com&quot;) :ok","ref":"Swoosh.Mailer.html","title":"Swoosh.Mailer","type":"module"},{"doc":"","ref":"Swoosh.Mailer.html#deliver/2","title":"Swoosh.Mailer.deliver/2","type":"function"},{"doc":"","ref":"Swoosh.Mailer.html#deliver_many/2","title":"Swoosh.Mailer.deliver_many/2","type":"function"},{"doc":"Interpolate system environment variables in the configuration.This function will transform all the {:system, &quot;ENV_VAR&quot;} tuples into their respective values grabbed from the process environment.","ref":"Swoosh.Mailer.html#interpolate_env_vars/1","title":"Swoosh.Mailer.interpolate_env_vars/1","type":"function"},{"doc":"Parse configs in the following order, later ones taking priority:mix configscompiled configs in Mailer moduledynamic configs passed into the functionsystem envs","ref":"Swoosh.Mailer.html#parse_config/4","title":"Swoosh.Mailer.parse_config/4","type":"function"},{"doc":"This module contains a set of assertions functions that you can import in your test cases.It is meant to be used with the Swoosh.Adapters.Test module.","ref":"Swoosh.TestAssertions.html","title":"Swoosh.TestAssertions","type":"module"},{"doc":"Asserts email was not sent.Performs exact matching of the email struct.","ref":"Swoosh.TestAssertions.html#assert_email_not_sent/1","title":"Swoosh.TestAssertions.assert_email_not_sent/1","type":"function"},{"doc":"Asserts any email was sent.","ref":"Swoosh.TestAssertions.html#assert_email_sent/0","title":"Swoosh.TestAssertions.assert_email_sent/0","type":"function"},{"doc":"Asserts email was sent.You pass a keyword list to match on specific params.Examplesiex&gt; alias Swoosh.Email iex&gt; import Swoosh.TestAssertions iex&gt; email = Email.new(subject: &quot;Hello, Avengers!&quot;) iex&gt; Swoosh.Adapters.Test.deliver(email, []) # assert a specific email was sent iex&gt; assert_email_sent email # assert an email with specific field(s) was sent iex&gt; assert_email_sent subject: &quot;Hello, Avengers!&quot;","ref":"Swoosh.TestAssertions.html#assert_email_sent/1","title":"Swoosh.TestAssertions.assert_email_sent/1","type":"function"},{"doc":"Asserts no emails were sent.","ref":"Swoosh.TestAssertions.html#assert_no_email_sent/0","title":"Swoosh.TestAssertions.assert_no_email_sent/0","type":"function"},{"doc":"Asserts no emails were sent.","ref":"Swoosh.TestAssertions.html#refute_email_sent/0","title":"Swoosh.TestAssertions.refute_email_sent/0","type":"macro"},{"doc":"Asserts email with attributes was not sent.Performs pattern matching using the given pattern, equivalent to pattern = email.When a list of attributes is given, they will be converted to a pattern.It converts list fields (:to, :cc, :bcc) to a single element list if a single value is given (to: &quot;email@example.com&quot; =&gt; to: [&quot;email@example.com&quot;]).After conversion, performs pattern matching using a map of email attributes, similar to %{attributes...} = email.","ref":"Swoosh.TestAssertions.html#refute_email_sent/1","title":"Swoosh.TestAssertions.refute_email_sent/1","type":"macro"},{"doc":"","ref":"Swoosh.AttachmentContentError.html","title":"Swoosh.AttachmentContentError","type":"exception"},{"doc":"","ref":"Swoosh.DeliveryError.html","title":"Swoosh.DeliveryError","type":"exception"},{"doc":"Callback implementation for Exception.message/1.","ref":"Swoosh.DeliveryError.html#message/1","title":"Swoosh.DeliveryError.message/1","type":"function"}]